import com.applix.tm1.TM1Bean;
import com.applix.tm1.TM1Chore;
import com.applix.tm1.TM1Server;
import com.applix.tm1.TM1Val;
import java.util.Date;
import java.text.DateFormat;
import java.text.SimpleDateFormat;


public class TM1ChoreExecute {

	public static void main(String[] args) {

		try
		{
			
			String TM1AdminHost = "";
			int TM1AdminPort = 0;
			String TM1DataServer = "";
			String TM1UID = "";
			String TM1PWD = "";
			String TM1Chore = "";
			
			if (args.length < 6)
			{
				System.out.println("Required number of arguments not supplied.");
				System.out.println("Usage: TM1ChoreExecute <AdminHost> <AdminPort> <Server> <UserID> <Password> <Chore Name>");
				System.out.println ("Result Code: -1");
				System.exit(-1);
			}
			
			TM1AdminHost = args[0];
			TM1AdminPort = Integer.parseInt(args[1].trim());
			TM1DataServer = args[2];
			TM1UID = args[3];
			TM1PWD = args[4];
			TM1Chore = args[5];
			
			System.out.println("Admin Host: " + TM1AdminHost);
			System.out.println("Admin Port: " + TM1AdminPort);
			System.out.println("Server: " + TM1DataServer);
			System.out.println("UID: " + TM1UID);
			System.out.println("PWD: " + TM1PWD);
			System.out.println("Chore: " + TM1Chore);
			
			DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
		        Date date = new Date();          
			System.out.println("START: Running TM1 Chore " + TM1Chore + " " + dateFormat.format(date) );
			
			TM1Bean bean = new TM1Bean();
			bean.setAdminHost(TM1AdminHost);
			bean.setAdminPort(TM1AdminPort);
	
			TM1Server tm1_server = bean.openConnection(TM1DataServer, TM1UID, TM1PWD);
			TM1Chore ti = tm1_server.getChore(TM1Chore);
			TM1Val TIresult = ti.execute();
			
			System.out.println ("Result Code: " + TIresult.getErrorCode());
			System.out.println("Result Message: " + TIresult.getErrorMessage());
			System.out.println("END: Running TM1 Chore " + TM1Chore + " "  + dateFormat.format(date) );
			System.exit(TIresult.getErrorCode());
				
			}
			catch (Exception e)
			{
				System.out.println(e.getMessage());
				System.out.println ("Result Code: -1");
				System.exit(-1);
	        }
	
	}
}
